
/*
	spitest.c : CDC-SPI test

	2010-01-22
	Osamu Tamura @ Recursion Co., Ltd.
*/

#define	_CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>

static const char	*title = "\n\tCDC-SPI Tester by Osamu Tamura\n";
static const char	*usage =   "\t\tusage: spitest port_number";


static int hex2bin( unsigned char *bin, char *hex )
{
	int				n;

	for( n=0; *hex; ) {
		if( *hex>' ' )
			bin[n++]	= (unsigned char)strtol( hex, &hex, 16 );
		else
			hex++;
	}
	return n;
}

static void bin2hex( char *hex, unsigned char *bin, int n )
{

	for( ; n>0; n-- )
		hex	+= sprintf( hex, " %02X", *bin++ );
	*hex	= 0;
}

int main(int argc, char *argv[])
{
	HANDLE			hCom;
	DWORD			rwlen;
	int				n, v, quit;
	char			*ptr, text[256];
	unsigned char	data[32];

	puts( title );

	if( argc!=2 ) {
		puts( usage );
		return -1;
	}

	/*	Open COM device	*/
	sprintf( text, "\\\\.\\COM%s", argv[1] );
	hCom = CreateFile( text, GENERIC_READ|GENERIC_WRITE,
					0, 0, OPEN_EXISTING, 0, 0 );
	if( hCom==INVALID_HANDLE_VALUE ) {
		printf( "\terror: COM%s is not available.", argv[1] );
		return -2;
	}

	for( quit=0; !quit; ) {

		printf( " com%s < ", argv[1] );
		gets( text );

		for( ptr=text; *ptr<=' '; ptr++ )
		;

		switch( *ptr ) {
			case 'Q':
			case 'q':	quit	= 1;
						break;
			case 'S':
			case 's':	for( ptr++; *ptr && *ptr!='0' && *ptr!='1'; ptr++ )
						;
						if( *ptr ) {
							n	= *ptr - '0';
							for( ptr++; *ptr && *ptr!='0' && *ptr!='1'; ptr++ )
							;
							if( *ptr ) {
								v	= *ptr - '0';
								EscapeCommFunction( hCom,
									n? (v? SETDTR:CLRDTR):(v? SETBREAK:CLRBREAK) );
							}
						}
						break;
			default:
						n	= hex2bin( data, text );
						WriteFile( hCom, data, n, &rwlen, 0 );
						Sleep(100 );
						ReadFile( hCom, data, rwlen, &rwlen, 0 );
						bin2hex( text, data, n );
						printf( " com%s >%s\n", argv[1], text );
		}
	}

	CloseHandle( hCom );
	return 0;
}
